package asw.asw830.client; 

import java.util.logging.Logger;

import asw.asw830.service.*;
import asw.util.logging.AswLogger;

/* client del servizio hello */ 
public class HelloClient {
	
	/* logger */ 
	private Logger logger = AswLogger.getInstance().getLogger("asw.asw830.client"); 

	private Hello hello;  
	
	public HelloClient(Hello hello) {
		this.hello = hello; 
	}
	
    public void run() {
    	/* usa il servizio Hello */ 
    	logger.info("Client: Ora uso il servizio Hello");
    	
    	/* dovrebbe restituire "Hello, Luca!" */ 
    	callSayHello("Luca"); 
    	
    	/* dovrebbe sollevare un'eccezione */ 
    	callSayHello(null); 

    	/* dovrebbe restituire "Hello, Paolo!" */ 
    	callSayHello("Paolo"); 

    	logger.info("Client: Ho finito di usare il servizio Hello");
    }
    
    /* chiama il servizio sayHello */ 
    private void callSayHello(String arg) {
    	/* usa il servizio Hello */ 
        try {
			logger.info("Client: calling sayHello(" + arg + ")"); 
			String result = hello.sayHello(arg);
			logger.info("Client: sayHello(" + arg + ") ==> " + result); 
        } catch (HelloException e) {
            logger.info("Client: HelloException: " + e.getMessage());
        } catch (RemoteException e) {
            logger.info("Client: RemoteException: " + e.getMessage());
        }
    }

}

