package asw.asw830.client.connector;

import asw.asw830.service.Hello;

/* Factory per il servizio Hello. */ 
public class ServiceFactory {
	
    private static ServiceFactory instance = null;    // per singleton 
    
    public static synchronized ServiceFactory getInstance() { 
        if (instance==null) instance = new ServiceFactory(); 
        return instance; 
    }

    /* Factory method per il servizio hello. */ 
    public Hello getHello(String[] args) {
    	String registryHost = "localhost"; 
    	if (args.length>0) {
    		registryHost = args[0]; 
    	}    	
    	String helloServiceName = "rmi:/asw830/Hello-cc"; 
        Hello service = null;
        try {
            service = new HelloClientProxy(registryHost, helloServiceName);
        } catch(Exception e) { 
        	e.printStackTrace(); 
        }
        return service; 
    }
}

