package asw.asw830.server; 

import asw.asw830.service.*;
import asw.asw830.service.rmi.*;
import asw.util.logging.AswLogger;

import java.util.logging.Logger;

/** 
 * Proxy per il servizio Hello.
 */ 
public class HelloServerProxy implements HelloRmiInterface {
	
	/* logger */ 
	private Logger logger = AswLogger.getInstance().getLogger("asw.asw830.server"); 

	/* il vero servizio hello */ 
	private Hello hello; 

	public HelloServerProxy(Hello hello) {
		super();
		this.hello = hello; 
	}

	/* 
	 * Invoca il vero metodo sayHello. 
	 * Trasforma un'eventuale eccezione remota generica in un'eccezione remota RMI. 
	 */
    public String sayHello(String name) throws HelloException, java.rmi.RemoteException {
			try {
	    		String result;
				result = hello.sayHello(name);
	    		logger.info("HelloServerProxy: hello.sayHello(" + name + ") --> " + result); 
	    		return result;
			} catch (HelloException e) {
				/* fai il logging e rilancia l'eccezione */ 
	    		logger.info("HelloServerProxy: HelloException: " + e.getMessage()); 
				throw e; 
			} catch (asw.asw830.service.RemoteException e) {
				/* fai il logging e converte l'eccezione */ 
	    		logger.info("HelloServerProxy: RemoteException: " + e.getMessage()); 
				throw new java.rmi.RemoteException(e.getMessage()); 
			}
	}
}

