package asw.asw830.counter.client;

import asw.asw830.counter.*; 
import asw.util.logging.AswLogger;
import asw.util.sleep.Sleeper;

import java.rmi.RemoteException;
import java.util.logging.Logger;

public class CounterClient {

	/* logger */ 
	private Logger logger = AswLogger.getInstance().getLogger("asw.asw830.counter.client"); 

	/* il servizio */ 
	private Counter counter; 

	public CounterClient(Counter counter) {
		this.counter = counter; 
	}
	
	public void run() {
        /* usa il servizio remoto */ 
        try {
        	logger.info("CounterClient: Ora uso il servizio Counter");
        	for (int i=0; i<25; i++) {
        		int result = counter.getCounter();
            	logger.info("CounterClient: counter.getCounter() ==> " + result);
        		/* introduci un ritardo causale (max 1 secondo) */
            	Sleeper.randomSleep(500,1000);
        	}
        } catch (RemoteException e) {
            logger.info("CounterClient: RemoteException: " + e.getMessage());
        }
    }

}
