package asw.asw830.sessioncounter.client;

import asw.asw830.sessioncounter.*;
import asw.util.logging.AswLogger;
import asw.util.sleep.Sleeper;

import java.rmi.RemoteException;
import java.util.logging.Logger;

public class SessionCounterClient {

	/* logger */ 
	private Logger logger = AswLogger.getInstance().getLogger("asw.asw830.sessioncounter.client"); 

	/* il servizio */ 
	SessionCounter sessionCounter; 
	
	public SessionCounterClient(SessionCounter sessionCounter) {
		this.sessionCounter = sessionCounter; 
	}
	
	public void run() {
        /* usa il servizio remoto */ 
        try {
            int counterId = sessionCounter.getId(); 
        	logger.info("SessionCounterClient: Ora uso il Session Counter: SessionCounter[" + counterId + "]");
        	for (int i=0; i<25; i++) {
        		int result = sessionCounter.getCounter();
            	logger.info("SessionCounterClient: SessionCounter[" + counterId + "].getCounter() ==> " + result);
        		/* introduci un ritardo causale (max 1 secondo) */
            	Sleeper.randomSleep(500,1000);
        	}
        } catch (RemoteException e) {
            logger.info("SessionCounterClient: RemoteException: " + e.getMessage());
        }
    }

}
